<script setup lang="ts">
import { ref } from "vue";

import MeSHFilter from "./components/mesh-filter/MeSHFilter.vue";
import { meshDescriptorList } from "./data/meshDescriptorsFlat";

const filter = ref<typeof MeSHFilter | null>(null);
const handleResetButtonClick = () => {
  filter.value?.clear();
};

const filterUIs = ref(false);
const itemUIs = [
  ["D018516", "D028321", "D009858"],
  ["D000011", "D000406"],
  ["D020215", "D000406"],
];

const currentLanguage = ref<"en" | "de">("en");

function randomDescriptor() {
  return meshDescriptorList[
    Math.floor(Math.random() * meshDescriptorList.length)
  ];
}
</script>

<template>
  <label>
    <input type="checkbox" v-model="filterUIs" />
    Filter UIs
  </label>
  <button @click="handleResetButtonClick">Reset</button>
  <button @click="filter?.addByUi(randomDescriptor().ui)">
    Add random MeSH term
  </button>
  <button @click="currentLanguage = currentLanguage === 'en' ? 'de' : 'en'">
    Toggle language ({{ currentLanguage }})
  </button>
  <div class="mesh-filter-container">
    <MeSHFilter
      ref="filter"
      class="mesh-filter"
      :lang="currentLanguage"
      :itemUIs="filterUIs ? itemUIs : undefined"
    />
  </div>
  <div class="selected-descriptors-total">
    <div
      class="tag"
      v-for="descriptor in filter?.meshDescriptorsSelectedTotal"
      :key="descriptor.ui"
    >
      {{ descriptor.name_de }}
    </div>
  </div>
</template>

<style scoped>
.mesh-filter-container {
  flex-grow: 1;
  display: flex;
  max-width: 100%;
}

.mesh-filter {
  flex-grow: 1;
  max-width: 100%;
}
</style>
